<div class="login-container">
  <div class="header-section">
    <app-page-header [pageInfo]="pageHeaderInfo"></app-page-header>
    </div>
  <div class="login-page">
    <div class="login-page-login">
      <div class="wrapper" *ngIf="showOIDCButton">
        <a  [href]="APP_CONFIG.backendUrls.oidc">
          <button class="button button-gl"
            type="submit" 
            [ngClass]="{'is-loading': formDisabled}"
            >Sign In With GrandLyon Connect</button>
        </a>
      </div>
      <div class="wrapper">
        <form [formGroup]="form" (ngSubmit)="login()">
          <div class="column-title">
            <span i18n="@@login.login">Log in</span>
          </div>

          <div class="errors-container">
            <ng-container [ngSwitch]="accountValidatationStatus">
              <p *ngSwitchCase="'pending'" class="is-warning" i18n="@@accountValidation.pending">
                Please wait while we are validating your account.
              </p>
              <p *ngSwitchCase="'validated'" i18n="@@accountValidation.validated" class="is-success">
                Your account has been successfully validated. You can now log in with your credentials.
              </p>
              <ng-container *ngSwitchCase="'failed'">
                <ng-container [ngSwitch]="errorType">
                  <p *ngSwitchCase="'noTokenProvided'" i18n="@@accountValidation.failed" class="is-warning">
                    The parameters provided are invalid, please use a valid link or go through the sign up process.
                  </p>
                  <p *ngSwitchCase="'existingAccount'" i18n="@@accountValidation.existingAccount" class="is-warning">
                    An account already exist for this email, please use your credentials to log in or signup with
                    another
                    email.
                  </p>

                  <p *ngSwitchDefault i18n="@@accountValidation.invalidOrExpired" class="is-warning">
                    We couldn't validate your account, whether the link is invalid or has expired (24h validity). Please
                    go
                    through the sign up process again.
                  </p>
                </ng-container>
              </ng-container>
            </ng-container>
            <ng-container *ngIf="errorStatus !== null">
              <p class="is-warning" *ngIf="errorStatus === 400; else genericErrorTemplate"
                i18n="@@login.incorrectCredentials">
                Your credentials are not correct.
              </p>
              <ng-template #genericErrorTemplate>
                <p class="is-warning" i18n="@@login.internalError">
                  Something went wrong, please try again later.
                </p>
              </ng-template>
            </ng-container>
          </div>

          <div class="field">
            <label class="label" for="username">Email</label>
            <p class="control">
              <input id="username" class="input" type="email" formControlName="username" [attr.autocomplete]="'email'"
                placeholder="Enter your email address" i18n-placeholder="@@login.emailPlaceholder"
                [ngClass]="{'has-error': fieldIsInvalid('username'), 'is-valid': fieldIsValid('username')}">
            </p>
            <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('username')">
              <div *ngIf="username.errors['required']" i18n="@@login.emailRequired">
                Email is required.
              </div>
              <div *ngIf="username.errors['email']" i18n="@@login.incorrectEmail">
                You need to provide a valid email.
              </div>
            </div>
          </div>

          <div class="field">
            <label class="label" for="password" i18n="@@login.password">Password</label>
            <span class="password-info">Votre mot de passe doit contenir au minimum :</span><span class="password-info has-text-weight-bold"> 6 caractères, un caractère spécial, un caractère en majuscule et un chiffre.</span>
            <div class="password-input-wrapper">
              <div class="control password-control">
                <input id="password" class="input" type="password" formControlName="password"
                  type="{{ showPassword ? 'text' : 'password' }}" placeholder="Enter your password"
                  i18n-placeholder="@@login.passwordPlaceholder"
                  [ngClass]="{'has-error': fieldIsInvalid('password'), 'is-valid': fieldIsValid('password')}">
                <p class="field show-password">
                  <input class="is-checkradio is-small" id="exampleCheckbox" type="checkbox" name="exampleCheckbox"
                    [value]="showPassword" (change)="showPassword = !showPassword">
                  <label i18n="@@login.showPassword" for="exampleCheckbox">Display password</label>
                </p>
              </div>
              <div *ngIf="fieldIsInvalid('password')" class="form-incorrect-field-message">
                <div *ngIf="password.errors['required']" i18n="@@login.passwordRequired">
                  Password is required.
                </div>
              </div>
            </div>
          </div>
          <div class="button-wrapper">
            <a class="button btn-blue-text" [routerLink]="['/', AppRoutes.passwordForgotten.uri]">
              <span i18n="@@login.passwordForgotten">Password forgotten?</span>
            </a>
            <button class="button button-gl" type="submit" [ngClass]="{'is-loading': formDisabled}"
              [disabled]="form.invalid || formDisabled" i18n="@@login.signInBtn">Sign In</button>
          </div>
        </form>
      </div>

    </div>
    <div class="login-page-signup">
      <div>
        <img src="./assets/img/connexion_illu.svg" alt="">
      </div>
      <div class="has-text-centered column-title">
        <span i18n="@@login.noAccount" class="no-account">Don't have an account yet?</span>
      </div>
      <div class="sign-up-link-container">
        <a class="button button-signup btn-blue-text" [routerLink]="['/', AppRoutes.signup.uri]">
          <span i18n="@@header.signUp">Sign Up</span>
        </a>
      </div>
      <span class="has-text-weight-bold" i18n="@@login.noAccountInfo.1">
        Why create an account ?
      </span>
      <span i18n="@@login.noAccountInfo.2">
        Your account allows you to access restricted data.
      </span>
      <span i18n="@@login.noAccountInfo.3">
        Creating an account is free and without obligation.
      </span>
      <span i18n="@@login.noAccountInfo.4">
        Unsubscription is possible at any time on request.
      </span>
    </div>
  </div>

</div>
